;;
;; fibonacci.asm
;;
;; Derived from an example by Philipp Koehn, 2016.
;; On exit, the accumulator holds the N_th item of
;; the fibonacci sequence.
;;
;; Decimal:  1,  1,  2,  3,  5,  8, 13, 21, 34, ...
;; Hex:      1,  1,  2,  3,  5,  8,  D, 15, 22, ...
;;


N_th        .equ 7

            ldx #N_th

START:      txa
            bne M01     ; f(0) = 0 ? no, continue
            rts         ; yes

M01:        dex         ; prepare for f(x - 1) call
            bne M02     ; f(1) = 1 ? no, continue
            rts         ; yes

M02:        txa         ; save X on stack
            pha
            jsr START   ; result of f(x - 1) in accumulator
            tay         ; let's put f(x - 1) aside
            pla         ; get X back from stack
            tax
            tya         ; get f(x - 1) back
            pha         ; save that for now on stack
            dex         ; prepare f(x - 2)
            jsr START
            sta TMP     ; store f(x - 2) for addition
            pla         ; f(x - 1) from stack
            clc
            adc TMP     ; f(x - 1) + f(x - 2)
            rts

TMP:        .blkb 2

